unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, SynEdit, SynHighlighterPas, Forms, Controls,
  Graphics, Dialogs, StdCtrls, LCLIntf, PasKeyMatcher;

type
  { TForm1 }

  TForm1 = class(TForm)
    CheckVisual: TButton;
    Label1: TLabel;
    Label2: TLabel;
    LoadButton: TButton;
    OpenDialog1: TOpenDialog;
    SpeedButton: TButton;
    SynEdit1: TSynEdit;
    SynPasSyn1: TSynPasSyn;
    procedure CheckVisualClick(Sender: TObject);
    procedure LoadButtonClick(Sender: TObject);
    procedure SpeedButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;
  press1, press2, diff: Integer;
  aList: TStringList;
  ListFromFile: TStringList;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.SpeedButtonClick(Sender: TObject);
var I, J: Integer;
begin
  if ListFromFile.Count = 0 then LoadButtonClick(nil);

  press1:= getTickCount;
  For I:= 1 to 1000 do
  for J:= 0 to ListFromFile.Count -1 do
  IsKeyWord(ListFromFile[J]);

  press2:=getTickCount;
  diff:= press2-press1;
  label1.caption:= IntToStr(diff);
  label2.caption:= 'Maches ' + IntToStr(ListFromFile.Count * 1000);
end;

procedure TForm1.LoadButtonClick(Sender: TObject);
begin
  ListFromFile.Clear;
  if OpenDialog1.Execute then
   begin
     aList.LoadFromFile(OpenDialog1.Filename);
   end;
  SynPasSyn1.SetLine(aList.Text, 0);
  while not SynPasSyn1.GetEol do
  begin
   SynPasSyn1.Next;
   if SynPasSyn1.GetTokenID in [tkIdentifier, tkKey] then ListFromFile.Add(SynPasSyn1.GetToken);
  end;
  aList.Clear;
end;

procedure TForm1.CheckVisualClick(Sender: TObject);
var I: Integer;
begin
  if ListFromFile.Count = 0 then LoadButtonClick(nil);
  for I:= 0 to ListFromFile.Count -1 do
  if IsKeyWord(ListFromFile[I]) then aList.Add(ListFromFile[I]);
  SynEdit1.Lines:= aList;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Randomize;
  aList:= TStringList.Create;
  ListFromFile:= TStringList.Create;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 aList.Free;
 ListFromFile.Free;
end;

end.

